Doomsday Engine - Bug #716

Compatible Dehacked file not loading
2009-06-08 14:37 - sonicdoommario

Status: Closed Start date: 2009-06-08
Priority: Normal % Done: 100%
Assignee: danij

Category:

Target version: 1.9.0-betab

Description

| was doing some more testing of Doomsday beta 6.3, and decided to load Alien Vendetta, along with its dehacked file (so | could get
its story texts replaced over Doom Il's story texts). | went on a level that was followed by a story text and even with the dehacked file
loaded, it still used Doom II's story text. And AV.deh was listed as compatible with Doomsday.

Labels: Data

History

#1 - 2009-06-08 15:31 - danij

The problem here is the completely bizarre way in which DeHackED choose to represent Text in its patch format. Rather than simply store indices to
text strings based on their position in the vanila binaries DeHackED instead choose to store two copies of the string to be replaced; the original
(extracted from the IWAD being modified) and the replacement.

Upon loading the patch, DeHackED would search all Text strings and replace all strings that match the original with the replacement.

This was a nice idea as it meant that text string patches were independant of the binaries so that if the offsets of the text strings themselves changed
the patches would still work.

However, now that we arn't patching a binary this makes the format of text string DEH patches somewhat unwieldy because if any of the "original"
strings have changed even slightly then the replacement will no longer work.

The solution therefore is to duplicate the original text strings from the vanilia IWAD in their entirety in their exact form in the dpDEHRead alongside

their counterpart string identifiers. When applying the patch, compare the original string in the patch with the original strings to determine the
identifier(s) and then do the replacement by string identifier.

#2 - 2009-07-01 13:43 - danij
Fixed in svn for 1.9.0-beta6.4
